***************************************************
* TECNICAS ECONOMETRICAS PARA AVALIACAO DE IMPACTO
* AULA PRATICA 11
* REVISAO
* 18/06/2008
***************************************************

*******************************************
* NAO RODAR EM SALA. APENAS DEMONSTRACAO
*******************************************

clear
set mem 500m
cd "C:\Issamu\pnad\pnad2006\2006\dados"

*** 2006 pessoas

infix ///
uf      5   -   6    ///
v0102   5   -   12   ///
v0103   13  -   15   ///
v0302   18  -   18   ///
v8005   27  -   29   ///
v0401   30  -   30   ///
v0404   33  -   33   ///
v0602   63  -   63   ///
v9001   153 -   153  ///
v4703   705 -   706  ///
v4706   709 -   710  ///
v4808   712 -   712  ///
v4729   807 -   811  ///
v4742   824 -   835  ///
using PES2006.txt, clear

keep if uf>20 & uf<30 & v4742>0 & v4742<=230
bys uf v0102 v0103: egen ncri5 = total(v8005<6)
bys uf v0102 v0103: egen ncri15 = total(v8005>5 & v8005<16)
bys uf v0102 v0103: egen ncri17 = total(v8005>15 & v8005<18)

drop if v4703==17

recode v0302 (2 = 1 "masculino") (4 = 0 "feminino"), g(sexo)
rename v8005 idade
g idade2 = idade^2
recode v0404 (2 6 = 1 "branco") (else = 0 "nao branco"), g(raca)
recode v0602 (2 = 1 "sim") (4 = 0 "nao"), g(estuda)
recode v9001 (1 = 1 "sim") (3 = 0 "nao"), g(trabalha)
rename v4703 anoest
g anoest2 = anoest^2
g comcart = v4706==1
g semcart = v4706==4
g trabdom = v4706==7
g cp = v4706==9
g trabagri = v4808==1
rename v4729 peso
rename v4742 renda

drop  v0302 v0404 v0602 v9001 v4706 v4808

preserve

keep if v0401 == 1 & idade>17

rename idade idadep
rename idade2 idade2p
rename anoest anoestp
rename anoest2 anoest2p
rename sexo sexop
rename raca racap

drop v0401 estuda trabalha ncri5 ncri15 ncri17 peso
tempfile x
sort  uf v0102 v0103
save `x', replace

restore

keep if idade>6 & idade<16
drop v0401 comcart semcart trabdom cp trabagri
sort  uf v0102 v0103
merge uf v0102 v0103 using `x'
keep if _merge==3
drop _merge

order uf v0102 v0103 sexo raca idade idade2 anoest anoest2 estuda ///
trabalha ncri5 ncri15 ncri17 renda peso idadep - trabagri

preserve

*** 2006 domicilio

infix ///
uf      5   -   6    ///
v0102   5   -   12   ///
v0103   13  -   15   ///
v0105   18  -   19   ///
v0201   22  -   22   ///
v0203   24  -   24   ///
v0206   28  -   29   ///
v0207   30  -   30   ///
v0211   58  -   58   ///
v0215   62  -   62   ///
v0217   66  -   66   ///
v0218   67  -   67   ///
v0219   68  -   68   ///
v2020   70  -   70   ///
v0221   71  -   71   ///
v0223   73  -   73   ///
v0224   74  -   74   ///
v0228   78  -   78   ///
v4105   83  -   83   ///
v4611   141 -   145  ///
v4614   146 -   157  ///
v4621   182 -   193  ///
v2403   199 -   199  ///
using DOM2006.txt, clear

keep if uf>20 & uf<30 &  v4621>0 & v4621<=230
keep if v0201==1
g lnmorador = ln(v0105)
recode v0203 (1 = 1 "alvenaria") (else = 0 "outros"), g(parede)
recode v0206 (1 = 1 "um") (2 = 2 "dois") (3/max = 3 "3+"), g(dormitorio)
tab dormitorio, g(dorm)
recode v0207 (1 2 = 1 "proprio") (else = 0 "outro"), g(moradia)
recode v0211 (1 = 1 "sim") (else = 0 "nao"), g(aguacanal)
recode v0215 (1 = 1 "sim") (else = 0 "nao"), g(banheiro)
recode v0217 (1 = 1 "sim") (else = 0 "nao"), g(redecolet)
recode v0217 (4 = 1 "sim") (else = 0 "nao"), g(fossarud)
recode v0218 (1 2 = 1 "coleta") (else = 0 "outro"), g(lixo1)
recode v0218 (3 = 1 "queimado") (else = 0 "outro"), g(lixo2)
recode v0219 (1 = 1 "eletrica") (else = 0 "outro"), g(luz)
recode v2020 (2 = 1 "sim") (else = 0 "nao"), g(fonefixo)
recode v0221 (1 = 1 "sim") (else = 0 "nao"), g(fogao)
recode v0223 (1 2 = 1 "gas") (else = 0 "outro"), g(combcoz)
recode v0224 (2 = 1 "sim") (else = 0 "nao"), g(filtro)
recode v0228 (2 4 = 1 "sim") (else = 0 "nao"), g(geladeira)
recode v4105 (1/3 = 1 "urbano") (else = 0 "rural"), g(area)
g tratado = v2403==1

keep uf v0102 v0103  v0105 lnmorador - tratado v4611
sort uf v0102 v0103
tempfile y
save `y', replace

restore
sort uf v0102 v0103
merge uf v0102 v0103 using `y'

keep if _merge==3
drop _merge

g cri = ncri5 + ncri15
replace cri = 18*cri
replace cri = 54 if cri>54
g cri1 = ncri17*30
replace cri1 = 60 if cri1>60

g tot = (cri + cri1)/v0105
sum renda [aw=peso]
replace renda = round(renda-tot) if tratado==1
sum renda [aw=peso]
drop if renda<1
drop cri cri1 tot

compress
save "F:\curso\base\criancas.dta", replace


**********************
*** INICIO DA AULA ***
**********************

clear
set mem 500m
cd "E:\curso"
sysdir set PLUS "E:\ado\plus"
sysdir set PERSONAL "E:\ado\personal"
sysdir set OLDPLACE "E:\ado"


use base\criancas.dta, clear

log using log\aula11.log, replace

tab tratado
tab tratado [aw=peso]
tab trabalha tratado [aw=peso], cell nofreq

mean trabalha [aw=peso], over(tratado)
di _b[1] - _b[0]
test _b[1] = _b[0]

regress trabalha tratado [aw=peso]
estimates store OLS

mean sexo-anoest2  [aw=peso], over(tratado)
test ([sexo]_b[1] = [sexo]_b[0]) ([raca]_b[1] = [raca]_b[0]) ///
    ([idade]_b[1] = [idade]_b[0]) ([idade2]_b[1] = [idade2]_b[0]) ///
    ([anoest]_b[1] = [anoest]_b[0]) ([anoest2]_b[1] = [anoest2]_b[0])

regress trabalha tratado sexo raca idade idade2 anoest anoest2 [aw=peso]

regress trabalha tratado sexo raca idade idade2 anoest anoest2 ///
    sexop racap idadep idade2p anoestp anoest2p comcart semcart trabdom cp ///
    ncri5 ncri15 renda [aw=peso]
estimates store OLSM

foreach var of varlist sexo raca idade idade2 anoest anoest2 sexop racap ///
    idadep idade2p anoestp anoest2p comcart semcart trabdom cp ncri5 ncri15 renda {
    summarize `var' [aw=peso] if e(sample)
    generate M_`var' = tratado*(`var' - r(mean))
}

regress trabalha tratado sexo raca idade idade2 anoest anoest2 ///
    sexop racap idadep idade2p anoestp anoest2p comcart semcart trabdom cp ///
    ncri5 ncri15 renda M* [aw=peso]
estimates store ATE

qui {
    foreach var of varlist sexo raca idade idade2 anoest anoest2 sexop racap ///
      idadep idade2p anoestp anoest2p comcart semcart trabdom cp ncri5 ncri15 renda {
        summarize `var' [aw=peso] if tratado==1 & e(sample)
        generate S_`var' = tratado*(`var' - r(mean))
    }
}

regress trabalha tratado sexo raca idade idade2 anoest anoest2 ///
    sexop racap idadep idade2p anoestp anoest2p comcart semcart trabdom cp ///
    ncri5 ncri15 renda S* [aw=peso]
estimates store ATT

summarize M_sexo if e(sample) & sexo==1
scalar Sexo = r(mean)

estimates restore ATE
lincom _b[tratado] + _b[M_sexo]*Sexo



*nnmatch trabalha tratado  menino branco idade anoest [pweight=v4729], ///
*   tc(att) m(4) metric(maha) bias(bias) robust(4)



global sel = ""
foreach var of varlist ncri5 ncri15 renda idadep anoestp sexop ///
    idade2p racap anoest2p comcart semcart trabdom cp trabagri lnmorador ///
    parede dorm2 dorm3 moradia aguacanal banheiro redecolet fossarud lixo1 ///
    lixo2 luz fonefixo fogao combcoz filtro geladeira area {
    corr tratado `var' [aw=peso]
    loc c`var' = abs(_result(4))
    if `c`var''>.05 {
        global sel = "$sel `var'"

    }
}

logit tratado $sel [pw=peso]
predict pscore

sum pscore if tratado==1
gen comsup = pscore>=r(min) & pscore<=r(max)
sum pscore if tratado==0
replace comsup = 0 if pscore<r(min) | pscore>r(max)

gen wpeso = (tratado/pscore) + ((1 - tratado)/(1 - pscore)) if comsup==1

gen wate = wpeso*peso

generate watt = wate*pscore

mean pscore $sel [aw=wate], over(tratado)
test ([pscore]_b[1] = [pscore]_b[0])

test ([ncri5]_b[1] = [ncri5]_b[0]) ///
([ncri15]_b[1] = [ncri15]_b[0]) ///
([renda]_b[1] = [renda]_b[0]) ///
([sexop]_b[1] = [sexop]_b[0]) ///
([anoestp]_b[1] = [anoestp]_b[0]) ///
([anoest2p]_b[1] = [anoest2p]_b[0]) ///
([comcart]_b[1] = [comcart]_b[0]) ///
([cp]_b[1] = [cp]_b[0]) ///
([trabagri]_b[1] = [trabagri]_b[0]) ///
([lnmorador]_b[1] = [lnmorador]_b[0]) ///
([dorm3]_b[1] = [dorm3]_b[0]) ///
([aguacanal]_b[1] = [aguacanal]_b[0]) ///
([banheiro]_b[1] = [banheiro]_b[0]) ///
([redecolet]_b[1] = [redecolet]_b[0]) ///
([lixo1]_b[1] = [lixo1]_b[0]) ///
([lixo2]_b[1] = [lixo2]_b[0]) ///
([luz]_b[1] = [luz]_b[0]) ///
([fonefixo]_b[1] = [fonefixo]_b[0]) ///
([fogao]_b[1] = [fogao]_b[0]) ///
([combcoz]_b[1] = [combcoz]_b[0]) ///
([geladeira]_b[1] = [geladeira]_b[0]) ///
([area]_b[1] = [area]_b[0])

watt trabalha tratado [aw=peso], pscore(pscore) comsup

reg trabalha tratado [aw=watt]

qui {
    foreach var of varlist sexo raca idade idade2 anoest anoest2 sexop racap ///
        idadep idade2p anoestp anoest2p comcart semcart trabdom cp ncri5 ncri15 renda {
        summarize `var' [aw=peso] if e(sample) & tratado==1
        generate SS_`var' = tratado*(`var' - r(mean))
    }
}

regress trabalha tratado sexo raca idade idade2 anoest anoest2 ///
    sexop racap idadep idade2p anoestp anoest2p comcart semcart trabdom cp ///
    ncri5 ncri15 renda SS* [aw=watt]
estimates store WATT

qui {
    foreach var of varlist sexo raca idade idade2 anoest anoest2 sexop racap idadep ///
        idade2p anoestp anoest2p comcart semcart trabdom cp ncri5 ncri15 renda {
        summarize `var' [aw=peso] if e(sample)
        generate MM_`var' = tratado*(`var' - r(mean))
    }
}

regress trabalha tratado sexo raca idade idade2 anoest anoest2 ///
    sexop racap idadep idade2p anoestp anoest2p comcart semcart trabdom cp ///
    ncri5 ncri15 renda MM* [aw=wate]
estimates store WATE

estimates table OLS OLSM ATE ATT WATT WATE, star

log close
