***************************************************
* TECNICAS ECONOMETRICAS PARA AVALIACAO DE IMPACTO
* AULA PRATICA 2
* DESCRICAO DA BASE, TESTES DE MEDIA E DISTRIBUICAO E
*    AVALIACAO DE IMPACTO
* 15/04/2008
***************************************************


* Relembrando a utilizao do profile.do

***************************************************
* Parametros do sistema
***************************************************

clear
set memory 100m
cd "E:\curso"
sysdir set PLUS "E:\ado\plus"
sysdir set PERSONAL "E:\ado\personal"
sysdir set OLDPLACE "E:\ado"


***************************************************
* A base de dados
***************************************************

* Abrindo um arquivo log.

log using log\aula2.log, replace


* Abrir e juntar as bases

use base\nswre74_treated.dta, clear

append using base\nswre74_control.dta


* Frequencia da variavel de tratamento

tabulate treat


***************************************************
* Anlise descritiva
***************************************************

describe
summarize

* Ordenar base por treat
sort treat

by treat: summarize

* Calcular media por tratado e controle
mean age-u75, over(treat)

* Estatisticas por tratado e controle
tabstat age-u75, by(treat) statistics(median mean sd p25) columns(statistics)



***************************************************
* Teste de igualdade de mdia
***************************************************

ttest age, by(treat)

mean age-u75, over(treat)

test ([age]_b[1] = [age]_b[0])


* Teste conjunto de diferenca de medias para as variaveis abaixo

test ([age]_b[1] = [age]_b[0]) ([black]_b[1] = [black]_b[0]) ///
        ([u75]_b[1] = [u75]_b[0]) ([re74]_b[1] = [re74]_b[0])


reg treat age edu black hisp married nodegree re74 re75 u74 u75

test black

test age edu black hisp married re74 re75 u74 u75



***************************************************
* Teste de igualdade de distribuio
***************************************************

* Visualizacao grafica

histogram age, by(treat)

generate lre74 = ln(re74)
twoway kdensity lre74 if treat==1 || kdensity lre74 if treat==0, lpattern(dash)

* Teste
ksmirnov re74, by(treat)


***************************************************
* Avaliao de Impacto
***************************************************

ttest re78, by(treat)

regress re78 treat

* Impactos diferenciado por sub-amostra
ttest re78 if edu<=10, by(treat)

ttest re78 if edu>10, by(treat)

* Inclusao de covariadas
regress re78 treat age edu black hisp married nodegree re74 re75 u74 u75

log close
