set mem 100m
cd "G:\curso"
sysdir set PLUS "G:\ado\plus"
sysdir set PERSONAL "G:\ado\personal"
sysdir set OLDPLACE "G:\ado"

log using log\aula4.log

cd "J:\dcp\Cursos\2013-1\Tcnicas_Avanadas_Polticas_Pblicas(DCP098)\curso"

use base\nswre74_treated.dta, clear

append using base\nswre74_control.dta

tabulate treat

describe

summarize

sort treat
by treat: summarize 

by treat, sort: summarize 

mean age-u75, over(treat)

tabstat age-u75, by(treat) statistics(median mean sd p25) columns(statistics)

ttest re78, by(treat)

mean age-u75, over(treat)
test [age]_b[1] = [age]_b[0]

test ([age]_b[1] = [age]_b[0]) ([black]_b[1] = [black]_b[0]) ([u75]_b[1] = [u75]_b[0]) ([re74]_b[1] = [re74]_b[0])

histogram re78, by(treat)

ksmirnov re78, by(treat)

*testes bsicos em estrutura cross-section

ttest re74, by(treat)
ttest re78, by(treat)

regress re78 treat

*testes de diferenas-em-diferenas

gen difre=re78-re74

ttest difre, by(treat)
regress difre treat

*one-group-before-and-after
sum difre if treat==1

*testes usando bootstrapping

bootstrap t=r(t), reps(10): ttest re74, by(treat)
bootstrap t=r(t), reps(10): ttest re78, by(treat)
bootstrap, reps(10): regress re78 treat

*agora rodando as equaes do Meyer: para isto precisamos criar um identificador
sort treat
gen id=_n
rename treat treat78
gen treat74=0

*tranformando em estrutura de painel
reshape long treat re, i(id) j(year)

*agora, a regresso Meyer
regress re treat

*criando os grupos de efeitos fixos e tendncia temporal

gen treatfix=1 if id>260
replace treatfix=0 if id<=260
gen timeeffect=1 if year==78
replace timeeffect=0 if year==74

*finalmente, a regresso DD

regress re timeeffect treatfix treat

*agora, a regresso com interaes de ordem maior: suponhamos que queiramos saber o efeito especfico da poltica para os 
*negros. Primeiro, vejamos se a distribuio  aleatria

tab black if year==78
ttest black if year==78 , by(treat)
prtest black if year==78 , by(treat)

gen blacktime=black*timeeffect 
gen blackfix=black*treatfix 
gen blacktreat=black*treat 

regress re timeeffect treatfix black treat blacktime blackfix blacktreat

log close









