***************************************************
* TECNICAS ECONOMETRICAS PARA AVALIACAO DE IMPACTO
* AULA PRATICA 7
* VARIAVEIS INSTRUMENTAIS
* 21/05/2008
***************************************************


* Relembrando a utilizao do profile.do

***************************************************
* Parametros do sistema
***************************************************

clear
set memory 100m
cd "E:\curso"
sysdir set PLUS "E:\ado\plus"
sysdir set PERSONAL "E:\ado\personal"
sysdir set OLDPLACE "E:\ado"


* Abrindo um arquivo log.

log using log\aula7.log, replace

***************************************************
* A base de dados
***************************************************

use base\nls80.dta, clear

* O que existe na base de dados

describe

summarize

* Criar variaveis binarias de educacao: > 12 = 1 para o indivduo
* e > 11 para os pais

g deduc = educ > 12
foreach name in feduc meduc {
    generate d`name' = `name'>11
}

* Dummy indicando se a pessoa  o filho mais velho

gen primeiro = brthord == 1


* ATE por OLS
reg lwage deduc exper married age black south urban

reg lwage deduc iq kww exper married age black south urban


* LATE
ivregress 2sls lwage (deduc =  dfeduc)

ivregress 2sls lwage (deduc =  primeiro)


* ATE por Estimador 2SLS

ivregress 2sls lwage iq kww exper married age black south urban (deduc =  dfeduc), small

ivregress 2sls lwage iq kww exper married age black south urban (deduc = primeiro), small


* ATE por considerando probabilidade no lugar da projecao

probit deduc iq kww exper married age black south urban dfeduc
predict edhat
ivregress 2sls lwage iq kww exper married age black south urban (deduc = edhat), small


* ATE por Estimador 2SLS passo a passo

reg deduc iq kww exper married age black south urban dfeduc
predict edhatli
reg lwage edhatli iq kww exper married age black south urban, vce(bootstrap, rep(100))


* ATE incluindo variaveis de interacao

* Ja temos a variavel edhat para educacao do pai como instrumento.
* Falta criar as interacoes

foreach name in iq kww exper tenure age married black south urban {
    qui sum `name'
    g dt`name' = deduc*(`name' - r(mean))
    g p`name' = edhat*(`name' - r(mean))
}

ivregress 2sls lwage iq kww exper married age black south urban dtiq-dturban ///
    (deduc = edhat piq-purban), small


* ATT incluindo variaveis de interacao

foreach name in iq kww exper tenure age married black south urban {
    qui sum `name' if deduc==1
    g dtt`name' = deduc*(`name' - r(mean))
    g pt`name' = edhat*(`name' - r(mean))
}

ivregress 2sls lwage iq kww exper married age black south urban dttiq-dtturban ///
    (deduc = edhat ptiq-pturban), small



* Propensity Score with Instrumental Variables
reg deduc iq kww exper married age black south urban dfeduc
predict pxz
g pxz2 = pxz^2
reg pxz iq kww exper married age black south urban
predict px
reg pxz2 iq kww exper married age black south urban
predict qx
reg lwage pxz px qx


* Endogenous Switching Model
treatreg lwage iq kww exper married age black south urban, ///
    treat(deduc = dfeduc iq kww exper married age black south urban)

log close
