clear
set mem 450m
cd "E:\curso"
sysdir set PLUS "e:\curso\ado\plus"
sysdir set PERSONAL "E:\curso\ado\personal"
sysdir set OLDPLACE "E:\curso\ado"

log using log\aula8.log, replace

**************
***1.A base de dados
**************
***Como anteriormente, a base utilizada para esta aula prtica do curso
***refere-se a uma amostra do programa National Supported Work Demonstration (NSW)
***em conjunto com a base do PSID.
***Sairo da base do PSID os candidatos ao grupo de controle do NSW,
***e a base final no representa mais um experimento aleatrio.

use base\nswpsid.dta, clear

**************
***2. Estimao do PS e calculo dos pesos
**************
***Vamos usar um logit:

logit TREAT AGE AGESQ EDUC EDUCSQ MARR BLACK HISP RE74 RE75 RE74SQ RE75SQ U74BLACK

***Salvar os valores preditos:
predict pscore

***Definir o suporte comum, com base nas informaes do grupo de tratamento:
summarize pscore if TREAT==1
generate comsup = pscore>=r(min) & pscore<=r(max)

***Corrigir o suporte comum, com base nas informaes do grupo de controle:
summarize pscore if TREAT==0
replace comsup = 0 if pscore<r(min) | pscore>r(max)

***Gerando os pesos para calculo do ATE:
generate wate = (TREAT/pscore) + ((1 - TREAT)/(1 - pscore)) if comsup==1

***Gerando os pesos para calculo do ATT:
generate watt = wate*pscore

***Gerando os pesos para calculo do ATU:
generate watu = wate*(1 - pscore)

**************
*3. Teste da propriedade de balano
**************
***Uma forma de verificar o ajuste  revisando as mdias das covariveis

***Mdias originais (normais)
mean pscore AGE EDUC MARR BLACK HISP RE74 RE75, over(TREAT)
estimates store normal

***Mdias ponderadas pelo PS
mean pscore AGE EDUC MARR BLACK HISP RE74 RE75 [aw=watt], over(TREAT)
estimates store ponderado

test ([pscore]_b[1] = [pscore]_b[0])
test ([AGE]_b[1] = [AGE]_b[0]) ([EDUC]_b[1] = [EDUC]_b[0]) ///
     ([MARR]_b[1] = [MARR]_b[0]) ([BLACK]_b[1] = [BLACK]_b[0]) ///
     ([HISP]_b[1] = [HISP]_b[0]) ([RE74]_b[1] = [RE74]_b[0]) ///
     ([RE75]_b[1] = [RE75]_b[0])

estimates table normal ponderado

**************
***4. Estimador semi-paramtrico
**************
***ATE:
regress RE78 TREAT [aw=wate]

quietly foreach var of varlist AGE EDUC MARR BLACK HISP RE74 RE75 {
    summarize `var' if e(sample)
    generate M_`var' = TREAT*(`var' - r(mean))
}

regress RE78 TREAT AGE EDUC MARR BLACK HISP RE74 RE75 M_* [aw=wate]

***ATT:
regress RE78 TREAT [aw=watt]

quietly foreach var of varlist AGE EDUC MARR BLACK HISP RE74 RE75 {
    summarize `var' if e(sample) & TREAT==1
    generate T_`var' = TREAT*(`var' - r(mean))
}

regress RE78 TREAT AGE EDUC MARR BLACK HISP RE74 RE75 T_* [aw=watt]

***ATU:
regress RE78 TREAT [aw=watu]

quietly foreach var of varlist AGE EDUC MARR BLACK HISP RE74 RE75 {
    summarize `var' if e(sample) & TREAT==0
    generate U_`var' = TREAT*(`var' - r(mean))
}

regress RE78 TREAT AGE EDUC MARR BLACK HISP RE74 RE75 U_* [aw=watu]

log close
