***************************************************
* TECNICAS ECONOMETRICAS PARA AVALIACAO DE IMPACTO
* AULA PRATICA 9
* REGRESSAO DESCONTINUA
* 11/06/2008
***************************************************

clear
set mem 200m
cd "E:\curso"
sysdir set PLUS "E:\ado\plus"
sysdir set PERSONAL "E:\ado\personal"
sysdir set OLDPLACE "E:\ado"


log using log\aula9.log, replace

* Sharp Design

use base\votex, clear

sum

* Variavel de interesse
tw scatter lne d if d<=0 || scatter lne d if d>0, xline(0)
tw lowess lne d if d<=0 || lowess lne d if d>0, xline(0)

* Variavel de tratamento
tw scatter win d if d<=0 || scatter win d if d>0, xline(0)

* Regressao nao parametrica na fronteira

* Bandwith = .1

* Passo a passo
g h = d>=-.1 & d<=.1

g yl = cond(h==1 & d<0, lne,0)
g yr = cond(h==1 & d>0, lne,0)

mean yl
loc xl = _b[yl]
mean yr
loc xr = _b[yr]

g obsl = h==1 & d<0
g obsr = h==1 & d>0
mean obsl
loc l = _b[obsl]
mean obsr
loc r = _b[obsr]

di (`xr'/`r') - (`xl'/`l')


* Modo alternativo
mean lne if h==1, over(win)
lincom _b[1] - _b[0]


* Local Liner Regression

* Passo a passo
reg lne d if h==1 & d<0
loc alfal = _b[_cons]

reg lne d if h==1 & d>0
loc alfar = _b[_cons]

di `alfar' - `alfal'

* Alternativamente

g dwin = d*win

reg lne d win dwin if h==1


* Um commando util  o rd
rd lne d, gr mbw(100)
bootstrap, reps(10): rd lne d, gr mbw(100)


* Fuzzy Design

use base\nordeste, clear

sum

* recodificar variavel para transformar em dummy
recode v2403 (3=0), copyrest g(treat)

tab renda treat

* conferindo se essas variaveis definem apenas um domicilio
bys uf v0102 v0103: g d = _N

* numero real de domicilios beneficiarios
bys renda: gen bf = cond(v2403==1, peso, 0)


preserve

* soma para cada valor da variavel renda
collapse (sum) peso bf , by(renda)

g pbf = bf/peso

* conferindo graficamente a descontinuidade
tw lowess pbf renda if renda<=60 || lowess pbf renda if renda>60 ,  xline(60)
tw lowess pbf renda if renda<=120 || lowess pbf renda if renda>120 ,  xline(120)
tw lowess pbf renda if renda<=149 || lowess pbf renda if renda>149 ,  xline(149)
restore

sort uf v0102 v0103
save base\nordeste1, replace

use base\nordestepess, clear

sort uf v0102 v0103
merge uf v0102 v0103 using base\nordeste1, keep(renda treat)

tab _merge
keep if _merge==3
drop _merge

recode v0602 (2 = 1) (4 = 0), g(escola)
recode v9001 (3 = 0), copyrest g(trabalho)

rename v4729 peso
bys renda: gen bf = cond(treat==1, peso, 0)

preserve

* soma para cada valor da variavel renda
collapse (sum) peso bf , by(renda)

g pbf = bf/peso

* conferindo graficamente a descontinuidade
tw lowess pbf renda if renda<=60 || lowess pbf renda if renda>60 ,  xline(60)
tw lowess pbf renda if renda<=120 || lowess pbf renda if renda>120 ,  xline(120)
tw lowess pbf renda if renda<=149 || lowess pbf renda if renda>149 ,  xline(149)
restore

preserve

* soma para cada valor da variavel renda
collapse (sum) peso escola trabalho , by(renda)

g pescola = escola/peso
g ptrab = trabalho/peso

* conferindo graficamente a descontinuidade
tw lowess pescola renda if renda<=149 || lowess pescola renda if renda>149 ,  xline(149)
tw lowess ptrab renda if renda<=149 || lowess ptrab renda if renda>149 ,  xline(149)

restore

* Bandwidth = 1
g h = renda>=148 & renda<=150

* Teste de descontinuidade
reg treat renda if h==1 & renda<=149
loc betal = _b[_cons]
loc sdl = _se[_cons]*e(N)
loc obsl = e(N)

reg treat renda if h==1 & renda>=149
loc betar = _b[_cons]
loc sdr = _se[_cons]*e(N)
loc obsr = e(N)

ttesti `obsr' `betar' `sdr' `obsl' `betal' `sdl'

* Local Linear Regression

drop h
g h = renda>=139 & renda<=159

* Frequencia a escola

* Passo a Passo

* Desvio em relacao ao cutoff
g xcl = renda - 149 if h==1 & renda<=149
g xcr = renda - 149 if h==1 & renda>149

* Calculando os limites para a variavel de interesse
reg escola xcl if xcl~=. [aw=peso]
loc alfayl = _b[_cons]
reg escola xcr if xcr~=. [aw=peso]
loc alfayr = _b[_cons]

* Calculando os limites para a variavel de tratamento
reg treat xcl if xcl~=. [aw=peso]
loc alfatl = _b[_cons]
reg treat xcr if xcr~=. [aw=peso]
loc alfatr = _b[_cons]


* Calculando o impacto
di (`alfayl' - `alfayr')/ (`alfatl' - `alfatr')


* Estimacao por MQ2E

* gerando variavais de interacao
g xcli = cond(renda>=139 & renda<=149,renda - 149,0)
g xcri = cond(renda>=150 & renda<=159,renda - 149,0)

* Instrumento
g instru = renda>=139 & renda<=149

ivregress 2sls escola xcli xcri (treat = instru) if h==1 [aw=peso]

log close
